/* Autogenerated with kurento-module-creator */

#ifndef __ZBAR_FILTER_IMPL_HPP__
#define __ZBAR_FILTER_IMPL_HPP__

#include "FilterImpl.hpp"
#include "ZBarFilter.hpp"
#include <EventHandler.hpp>

namespace kurento
{

class MediaPipeline;
class ZBarFilterImpl;

void Serialize (std::shared_ptr<ZBarFilterImpl> &object,
                JsonSerializer &serializer);

class ZBarFilterImpl : public FilterImpl, public virtual ZBarFilter
{

public:

  ZBarFilterImpl (const boost::property_tree::ptree &conf,
                  std::shared_ptr<MediaPipeline> mediaPipeline);

  virtual ~ZBarFilterImpl ();

  /* Next methods are automatically implemented by code generator */
  virtual bool connect (const std::string &eventType,
                        std::shared_ptr<EventHandler> handler);

  sigc::signal<void, CodeFound> signalCodeFound;

  virtual void invoke (std::shared_ptr<MediaObjectImpl> obj,
                       const std::string &methodName, const Json::Value &params,
                       Json::Value &response);

  virtual void Serialize (JsonSerializer &serializer);

private:

  GstElement *zbar;
  gulong bus_handler_id;

  guint64 lastTs = G_GUINT64_CONSTANT (0);
  std::string lastType;
  std::string lastSymbol;

  std::function<void (GstMessage *) > busMessageLambda;

  void barcodeDetected (guint64 ts, std::string &type, std::string &symbol);

  class StaticConstructor
  {
  public:
    StaticConstructor();
  };

  static StaticConstructor staticConstructor;

};

} /* kurento */

#endif /*  __ZBAR_FILTER_IMPL_HPP__ */
